package com.its.op.service.its.vds;

import com.its.op.dao.repository.its.vds.TbVdsDtctRltnLinkRepository;
import com.its.op.dto.its.vds.TbVdsDtctRltnLinkDto;
import com.its.op.entity.its.vds.TbVdsDtctLinkRltn;
import com.its.op.entity.its.vds.TbVdsDtctLinkRltnKey;
import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.ArrayList;
import java.util.List;
import java.util.Optional;

@Slf4j
@RequiredArgsConstructor
@Service
public class TbVdsDtctLinkRltnService {

    private final TbVdsDtctRltnLinkRepository repo;

    // 전체 데이터 조회
    @Transactional(readOnly = true)
    public List<TbVdsDtctRltnLinkDto> findAll() {
        List<TbVdsDtctRltnLinkDto> result = new ArrayList<>();
        List<TbVdsDtctLinkRltn> data = this.repo.findAll();
        for (TbVdsDtctLinkRltn entity : data) {
            result.add(entity.toDto());
        }
        return result;
    }

    // 데이터 변경 또는 생성-목록(데이터가 존재하면 업데이트 없으면 신규로 생성)
    @Transactional
    public List<TbVdsDtctRltnLinkDto> mergeInfoList(List<TbVdsDtctRltnLinkDto.TbVdsDtctLinkRltnUpdReq> reqList) {
        List<TbVdsDtctRltnLinkDto> result = new ArrayList<>();
        for (TbVdsDtctRltnLinkDto.TbVdsDtctLinkRltnUpdReq req : reqList) {
            TbVdsDtctLinkRltn obj = req.toEntity();
            this.repo.save(obj);
            result.add(obj.toDto());
        }
        return result;
    }

    // 데이터 변경 또는 생성-개별(데이터가 존재하면 업데이트 없으면 신규로 생성)
    @Transactional
    public TbVdsDtctRltnLinkDto mergeInfo(TbVdsDtctRltnLinkDto.TbVdsDtctLinkRltnUpdReq req) {
        TbVdsDtctLinkRltn obj = req.toEntity();
        this.repo.save(obj);
        return obj.toDto();
    }

    // 정보 삭제-목록, 존재하는 데이터 만 삭제
    @Transactional
    public List<TbVdsDtctRltnLinkDto> deleteByIds(List<TbVdsDtctLinkRltnKey> ids) {
        List<TbVdsDtctRltnLinkDto> result = new ArrayList<>();
        for (TbVdsDtctLinkRltnKey id : ids) {
            Optional<TbVdsDtctLinkRltn> obj = this.repo.findById(id.getDtctNmbr());
            if (obj.isPresent()) {
                this.repo.deleteById(id.getDtctNmbr());
                result.add(obj.get().toDto());
            }
        }
        return result;
    }

}
